package net.launchpad.vide.flowchart.diagram.navigator;

import net.launchpad.vide.flowchart.Program;
import net.launchpad.vide.flowchart.diagram.edit.parts.FunctionalCommandCodeEditPart;
import net.launchpad.vide.flowchart.diagram.edit.parts.FunctionalCommandEditPart;
import net.launchpad.vide.flowchart.diagram.edit.parts.FunctionalCommandOutputEditPart;
import net.launchpad.vide.flowchart.diagram.edit.parts.ProgramEditPart;
import net.launchpad.vide.flowchart.diagram.part.FlowchartDiagramEditorPlugin;
import net.launchpad.vide.flowchart.diagram.part.FlowchartVisualIDRegistry;
import net.launchpad.vide.flowchart.diagram.providers.FlowchartElementTypes;
import net.launchpad.vide.flowchart.diagram.providers.FlowchartParserProvider;

import org.eclipse.gmf.runtime.common.ui.services.parser.IParser;
import org.eclipse.gmf.runtime.common.ui.services.parser.ParserOptions;
import org.eclipse.gmf.runtime.emf.core.util.EObjectAdapter;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.jface.resource.ImageRegistry;
import org.eclipse.jface.viewers.ITreePathLabelProvider;
import org.eclipse.jface.viewers.LabelProvider;
import org.eclipse.jface.viewers.TreePath;
import org.eclipse.jface.viewers.ViewerLabel;
import org.eclipse.swt.graphics.Image;
import org.eclipse.ui.IMemento;
import org.eclipse.ui.navigator.ICommonContentExtensionSite;
import org.eclipse.ui.navigator.ICommonLabelProvider;

/**
 * @generated
 */
public class FlowchartNavigatorLabelProvider extends LabelProvider implements
		ICommonLabelProvider, ITreePathLabelProvider {

	/**
	 * @generated
	 */
	static {
		FlowchartDiagramEditorPlugin
				.getInstance()
				.getImageRegistry()
				.put("Navigator?UnknownElement", ImageDescriptor.getMissingImageDescriptor()); //$NON-NLS-1$
		FlowchartDiagramEditorPlugin
				.getInstance()
				.getImageRegistry()
				.put("Navigator?ImageNotFound", ImageDescriptor.getMissingImageDescriptor()); //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	public void updateLabel(ViewerLabel label, TreePath elementPath) {
		Object element = elementPath.getLastSegment();
		if (element instanceof FlowchartNavigatorItem
				&& !isOwnView(((FlowchartNavigatorItem) element).getView())) {
			return;
		}
		label.setText(getText(element));
		label.setImage(getImage(element));
	}

	/**
	 * @generated
	 */
	public Image getImage(Object element) {
		if (element instanceof FlowchartNavigatorGroup) {
			FlowchartNavigatorGroup group = (FlowchartNavigatorGroup) element;
			return FlowchartDiagramEditorPlugin.getInstance().getBundledImage(
					group.getIcon());
		}

		if (element instanceof FlowchartNavigatorItem) {
			FlowchartNavigatorItem navigatorItem = (FlowchartNavigatorItem) element;
			if (!isOwnView(navigatorItem.getView())) {
				return super.getImage(element);
			}
			return getImage(navigatorItem.getView());
		}

		return super.getImage(element);
	}

	/**
	 * @generated
	 */
	public Image getImage(View view) {
		switch (FlowchartVisualIDRegistry.getVisualID(view)) {
		case FunctionalCommandOutputEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Link?http://flowchart/1.0?FunctionalCommand?output", FlowchartElementTypes.FunctionalCommandOutput_4001); //$NON-NLS-1$
		case ProgramEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Diagram?http://flowchart/1.0?Program", FlowchartElementTypes.Program_1000); //$NON-NLS-1$
		case FunctionalCommandEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?http://flowchart/1.0?FunctionalCommand", FlowchartElementTypes.FunctionalCommand_2001); //$NON-NLS-1$
		}
		return getImage("Navigator?UnknownElement", null); //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private Image getImage(String key, IElementType elementType) {
		ImageRegistry imageRegistry = FlowchartDiagramEditorPlugin
				.getInstance().getImageRegistry();
		Image image = imageRegistry.get(key);
		if (image == null && elementType != null
				&& FlowchartElementTypes.isKnownElementType(elementType)) {
			image = FlowchartElementTypes.getImage(elementType);
			imageRegistry.put(key, image);
		}

		if (image == null) {
			image = imageRegistry.get("Navigator?ImageNotFound"); //$NON-NLS-1$
			imageRegistry.put(key, image);
		}
		return image;
	}

	/**
	 * @generated
	 */
	public String getText(Object element) {
		if (element instanceof FlowchartNavigatorGroup) {
			FlowchartNavigatorGroup group = (FlowchartNavigatorGroup) element;
			return group.getGroupName();
		}

		if (element instanceof FlowchartNavigatorItem) {
			FlowchartNavigatorItem navigatorItem = (FlowchartNavigatorItem) element;
			if (!isOwnView(navigatorItem.getView())) {
				return null;
			}
			return getText(navigatorItem.getView());
		}

		return super.getText(element);
	}

	/**
	 * @generated
	 */
	public String getText(View view) {
		if (view.getElement() != null && view.getElement().eIsProxy()) {
			return getUnresolvedDomainElementProxyText(view);
		}
		switch (FlowchartVisualIDRegistry.getVisualID(view)) {
		case FunctionalCommandOutputEditPart.VISUAL_ID:
			return getFunctionalCommandOutput_4001Text(view);
		case ProgramEditPart.VISUAL_ID:
			return getProgram_1000Text(view);
		case FunctionalCommandEditPart.VISUAL_ID:
			return getFunctionalCommand_2001Text(view);
		}
		return getUnknownElementText(view);
	}

	/**
	 * @generated
	 */
	private String getFunctionalCommand_2001Text(View view) {
		IParser parser = FlowchartParserProvider.getParser(
				FlowchartElementTypes.FunctionalCommand_2001,
				view.getElement() != null ? view.getElement() : view,
				FlowchartVisualIDRegistry
						.getType(FunctionalCommandCodeEditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			FlowchartDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 5001); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getFunctionalCommandOutput_4001Text(View view) {
		return ""; //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private String getProgram_1000Text(View view) {
		Program domainModelElement = (Program) view.getElement();
		if (domainModelElement != null) {
			return domainModelElement.getName();
		} else {
			FlowchartDiagramEditorPlugin.getInstance().logError(
					"No domain element for view with visualID = " + 1000); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getUnknownElementText(View view) {
		return "<UnknownElement Visual_ID = " + view.getType() + ">"; //$NON-NLS-1$  //$NON-NLS-2$
	}

	/**
	 * @generated
	 */
	private String getUnresolvedDomainElementProxyText(View view) {
		return "<Unresolved domain element Visual_ID = " + view.getType() + ">"; //$NON-NLS-1$  //$NON-NLS-2$
	}

	/**
	 * @generated
	 */
	public void init(ICommonContentExtensionSite aConfig) {
	}

	/**
	 * @generated
	 */
	public void restoreState(IMemento aMemento) {
	}

	/**
	 * @generated
	 */
	public void saveState(IMemento aMemento) {
	}

	/**
	 * @generated
	 */
	public String getDescription(Object anElement) {
		return null;
	}

	/**
	 * @generated
	 */
	private boolean isOwnView(View view) {
		return ProgramEditPart.MODEL_ID.equals(FlowchartVisualIDRegistry
				.getModelID(view));
	}

}
