package net.launchpad.vide.flowchart.diagram.part;

import java.util.Collection;
import java.util.Collections;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

import net.launchpad.vide.flowchart.FlowchartPackage;
import net.launchpad.vide.flowchart.FunctionalCommand;
import net.launchpad.vide.flowchart.Program;
import net.launchpad.vide.flowchart.diagram.edit.parts.FunctionalCommandEditPart;
import net.launchpad.vide.flowchart.diagram.edit.parts.FunctionalCommandOutputEditPart;
import net.launchpad.vide.flowchart.diagram.edit.parts.ProgramEditPart;
import net.launchpad.vide.flowchart.diagram.providers.FlowchartElementTypes;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.gmf.runtime.notation.View;

/**
 * @generated
 */
public class FlowchartDiagramUpdater {

	/**
	 * @generated
	 */
	public static List<FlowchartNodeDescriptor> getSemanticChildren(View view) {
		switch (FlowchartVisualIDRegistry.getVisualID(view)) {
		case ProgramEditPart.VISUAL_ID:
			return getProgram_1000SemanticChildren(view);
		}
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<FlowchartNodeDescriptor> getProgram_1000SemanticChildren(
			View view) {
		if (!view.isSetElement()) {
			return Collections.emptyList();
		}
		Program modelElement = (Program) view.getElement();
		LinkedList<FlowchartNodeDescriptor> result = new LinkedList<FlowchartNodeDescriptor>();
		for (Iterator<?> it = modelElement.getFunctionalCommands().iterator(); it
				.hasNext();) {
			FunctionalCommand childElement = (FunctionalCommand) it.next();
			int visualID = FlowchartVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == FunctionalCommandEditPart.VISUAL_ID) {
				result.add(new FlowchartNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List<FlowchartLinkDescriptor> getContainedLinks(View view) {
		switch (FlowchartVisualIDRegistry.getVisualID(view)) {
		case ProgramEditPart.VISUAL_ID:
			return getProgram_1000ContainedLinks(view);
		case FunctionalCommandEditPart.VISUAL_ID:
			return getFunctionalCommand_2001ContainedLinks(view);
		}
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<FlowchartLinkDescriptor> getIncomingLinks(View view) {
		switch (FlowchartVisualIDRegistry.getVisualID(view)) {
		case FunctionalCommandEditPart.VISUAL_ID:
			return getFunctionalCommand_2001IncomingLinks(view);
		}
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<FlowchartLinkDescriptor> getOutgoingLinks(View view) {
		switch (FlowchartVisualIDRegistry.getVisualID(view)) {
		case FunctionalCommandEditPart.VISUAL_ID:
			return getFunctionalCommand_2001OutgoingLinks(view);
		}
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<FlowchartLinkDescriptor> getProgram_1000ContainedLinks(
			View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<FlowchartLinkDescriptor> getFunctionalCommand_2001ContainedLinks(
			View view) {
		FunctionalCommand modelElement = (FunctionalCommand) view.getElement();
		LinkedList<FlowchartLinkDescriptor> result = new LinkedList<FlowchartLinkDescriptor>();
		result.addAll(getOutgoingFeatureModelFacetLinks_FunctionalCommand_Output_4001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<FlowchartLinkDescriptor> getFunctionalCommand_2001IncomingLinks(
			View view) {
		FunctionalCommand modelElement = (FunctionalCommand) view.getElement();
		Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences = EcoreUtil.CrossReferencer
				.find(view.eResource().getResourceSet().getResources());
		LinkedList<FlowchartLinkDescriptor> result = new LinkedList<FlowchartLinkDescriptor>();
		result.addAll(getIncomingFeatureModelFacetLinks_FunctionalCommand_Output_4001(
				modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<FlowchartLinkDescriptor> getFunctionalCommand_2001OutgoingLinks(
			View view) {
		FunctionalCommand modelElement = (FunctionalCommand) view.getElement();
		LinkedList<FlowchartLinkDescriptor> result = new LinkedList<FlowchartLinkDescriptor>();
		result.addAll(getOutgoingFeatureModelFacetLinks_FunctionalCommand_Output_4001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<FlowchartLinkDescriptor> getIncomingFeatureModelFacetLinks_FunctionalCommand_Output_4001(
			FunctionalCommand target,
			Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences) {
		LinkedList<FlowchartLinkDescriptor> result = new LinkedList<FlowchartLinkDescriptor>();
		Collection<EStructuralFeature.Setting> settings = crossReferences
				.get(target);
		for (EStructuralFeature.Setting setting : settings) {
			if (setting.getEStructuralFeature() == FlowchartPackage.eINSTANCE
					.getFunctionalCommand_Output()) {
				result.add(new FlowchartLinkDescriptor(setting.getEObject(),
						target,
						FlowchartElementTypes.FunctionalCommandOutput_4001,
						FunctionalCommandOutputEditPart.VISUAL_ID));
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<FlowchartLinkDescriptor> getOutgoingFeatureModelFacetLinks_FunctionalCommand_Output_4001(
			FunctionalCommand source) {
		LinkedList<FlowchartLinkDescriptor> result = new LinkedList<FlowchartLinkDescriptor>();
		for (Iterator<?> destinations = source.getOutput().iterator(); destinations
				.hasNext();) {
			FunctionalCommand destination = (FunctionalCommand) destinations
					.next();
			result.add(new FlowchartLinkDescriptor(source, destination,
					FlowchartElementTypes.FunctionalCommandOutput_4001,
					FunctionalCommandOutputEditPart.VISUAL_ID));
		}
		return result;
	}

}
