package net.launchpad.vide.flowchart.diagram.part;

import net.launchpad.vide.flowchart.FlowchartPackage;
import net.launchpad.vide.flowchart.Program;
import net.launchpad.vide.flowchart.diagram.edit.parts.FunctionalCommandCodeEditPart;
import net.launchpad.vide.flowchart.diagram.edit.parts.FunctionalCommandEditPart;
import net.launchpad.vide.flowchart.diagram.edit.parts.ProgramEditPart;

import org.eclipse.core.runtime.Platform;
import org.eclipse.emf.ecore.EAnnotation;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.gmf.runtime.notation.Diagram;
import org.eclipse.gmf.runtime.notation.View;

/**
 * This registry is used to determine which type of visual object should be
 * created for the corresponding Diagram, Node, ChildNode or Link represented
 * by a domain model object.
 * 
 * @generated
 */
public class FlowchartVisualIDRegistry {

	/**
	 * @generated
	 */
	private static final String DEBUG_KEY = "net.launchpad.vide.diagram/debug/visualID"; //$NON-NLS-1$

	/**
	 * @generated
	 */
	public static int getVisualID(View view) {
		if (view instanceof Diagram) {
			if (ProgramEditPart.MODEL_ID.equals(view.getType())) {
				return ProgramEditPart.VISUAL_ID;
			} else {
				return -1;
			}
		}
		return net.launchpad.vide.flowchart.diagram.part.FlowchartVisualIDRegistry
				.getVisualID(view.getType());
	}

	/**
	 * @generated
	 */
	public static String getModelID(View view) {
		View diagram = view.getDiagram();
		while (view != diagram) {
			EAnnotation annotation = view.getEAnnotation("Shortcut"); //$NON-NLS-1$
			if (annotation != null) {
				return (String) annotation.getDetails().get("modelID"); //$NON-NLS-1$
			}
			view = (View) view.eContainer();
		}
		return diagram != null ? diagram.getType() : null;
	}

	/**
	 * @generated
	 */
	public static int getVisualID(String type) {
		try {
			return Integer.parseInt(type);
		} catch (NumberFormatException e) {
			if (Boolean.TRUE.toString().equalsIgnoreCase(
					Platform.getDebugOption(DEBUG_KEY))) {
				FlowchartDiagramEditorPlugin.getInstance().logError(
						"Unable to parse view type as a visualID number: "
								+ type);
			}
		}
		return -1;
	}

	/**
	 * @generated
	 */
	public static String getType(int visualID) {
		return Integer.toString(visualID);
	}

	/**
	 * @generated
	 */
	public static int getDiagramVisualID(EObject domainElement) {
		if (domainElement == null) {
			return -1;
		}
		if (FlowchartPackage.eINSTANCE.getProgram().isSuperTypeOf(
				domainElement.eClass())
				&& isDiagram((Program) domainElement)) {
			return ProgramEditPart.VISUAL_ID;
		}
		return -1;
	}

	/**
	 * @generated
	 */
	public static int getNodeVisualID(View containerView, EObject domainElement) {
		if (domainElement == null) {
			return -1;
		}
		String containerModelID = net.launchpad.vide.flowchart.diagram.part.FlowchartVisualIDRegistry
				.getModelID(containerView);
		if (!ProgramEditPart.MODEL_ID.equals(containerModelID)) {
			return -1;
		}
		int containerVisualID;
		if (ProgramEditPart.MODEL_ID.equals(containerModelID)) {
			containerVisualID = net.launchpad.vide.flowchart.diagram.part.FlowchartVisualIDRegistry
					.getVisualID(containerView);
		} else {
			if (containerView instanceof Diagram) {
				containerVisualID = ProgramEditPart.VISUAL_ID;
			} else {
				return -1;
			}
		}
		switch (containerVisualID) {
		case ProgramEditPart.VISUAL_ID:
			if (FlowchartPackage.eINSTANCE.getFunctionalCommand()
					.isSuperTypeOf(domainElement.eClass())) {
				return FunctionalCommandEditPart.VISUAL_ID;
			}
			break;
		}
		return -1;
	}

	/**
	 * @generated
	 */
	public static boolean canCreateNode(View containerView, int nodeVisualID) {
		String containerModelID = net.launchpad.vide.flowchart.diagram.part.FlowchartVisualIDRegistry
				.getModelID(containerView);
		if (!ProgramEditPart.MODEL_ID.equals(containerModelID)) {
			return false;
		}
		int containerVisualID;
		if (ProgramEditPart.MODEL_ID.equals(containerModelID)) {
			containerVisualID = net.launchpad.vide.flowchart.diagram.part.FlowchartVisualIDRegistry
					.getVisualID(containerView);
		} else {
			if (containerView instanceof Diagram) {
				containerVisualID = ProgramEditPart.VISUAL_ID;
			} else {
				return false;
			}
		}
		switch (containerVisualID) {
		case ProgramEditPart.VISUAL_ID:
			if (FunctionalCommandEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case FunctionalCommandEditPart.VISUAL_ID:
			if (FunctionalCommandCodeEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		}
		return false;
	}

	/**
	 * @generated
	 */
	public static int getLinkWithClassVisualID(EObject domainElement) {
		if (domainElement == null) {
			return -1;
		}
		return -1;
	}

	/**
	 * User can change implementation of this method to handle some specific
	 * situations not covered by default logic.
	 * 
	 * @generated
	 */
	private static boolean isDiagram(Program element) {
		return true;
	}

}
