/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package net.launchpad.vide.flowchart;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see net.launchpad.vide.flowchart.FlowchartFactory
 * @model kind="package"
 * @generated
 */
public interface FlowchartPackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "flowchart";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http://flowchart/1.0";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "flowchart";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	FlowchartPackage eINSTANCE = net.launchpad.vide.flowchart.impl.FlowchartPackageImpl.init();

	/**
	 * The meta object id for the '{@link net.launchpad.vide.flowchart.impl.ProgramImpl <em>Program</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see net.launchpad.vide.flowchart.impl.ProgramImpl
	 * @see net.launchpad.vide.flowchart.impl.FlowchartPackageImpl#getProgram()
	 * @generated
	 */
	int PROGRAM = 0;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROGRAM__NAME = 0;

	/**
	 * The feature id for the '<em><b>Blocks</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROGRAM__BLOCKS = 1;

	/**
	 * The feature id for the '<em><b>Functional Commands</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROGRAM__FUNCTIONAL_COMMANDS = 2;

	/**
	 * The number of structural features of the '<em>Program</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROGRAM_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link net.launchpad.vide.flowchart.impl.BlockImpl <em>Block</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see net.launchpad.vide.flowchart.impl.BlockImpl
	 * @see net.launchpad.vide.flowchart.impl.FlowchartPackageImpl#getBlock()
	 * @generated
	 */
	int BLOCK = 1;

	/**
	 * The feature id for the '<em><b>Commands</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BLOCK__COMMANDS = 0;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BLOCK__NAME = 1;

	/**
	 * The number of structural features of the '<em>Block</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BLOCK_FEATURE_COUNT = 2;

	/**
	 * The meta object id for the '{@link net.launchpad.vide.flowchart.impl.CommandImpl <em>Command</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see net.launchpad.vide.flowchart.impl.CommandImpl
	 * @see net.launchpad.vide.flowchart.impl.FlowchartPackageImpl#getCommand()
	 * @generated
	 */
	int COMMAND = 2;

	/**
	 * The number of structural features of the '<em>Command</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMAND_FEATURE_COUNT = 0;

	/**
	 * The meta object id for the '{@link net.launchpad.vide.flowchart.impl.BranchingImpl <em>Branching</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see net.launchpad.vide.flowchart.impl.BranchingImpl
	 * @see net.launchpad.vide.flowchart.impl.FlowchartPackageImpl#getBranching()
	 * @generated
	 */
	int BRANCHING = 3;

	/**
	 * The feature id for the '<em><b>True Block</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BRANCHING__TRUE_BLOCK = COMMAND_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>False Block</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BRANCHING__FALSE_BLOCK = COMMAND_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Condition</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BRANCHING__CONDITION = COMMAND_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Branching</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BRANCHING_FEATURE_COUNT = COMMAND_FEATURE_COUNT + 3;

	/**
	 * The meta object id for the '{@link net.launchpad.vide.flowchart.impl.LoopImpl <em>Loop</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see net.launchpad.vide.flowchart.impl.LoopImpl
	 * @see net.launchpad.vide.flowchart.impl.FlowchartPackageImpl#getLoop()
	 * @generated
	 */
	int LOOP = 4;

	/**
	 * The feature id for the '<em><b>Body</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOOP__BODY = COMMAND_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Condition</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOOP__CONDITION = COMMAND_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Loop</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOOP_FEATURE_COUNT = COMMAND_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link net.launchpad.vide.flowchart.impl.SimpleCommandImpl <em>Simple Command</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see net.launchpad.vide.flowchart.impl.SimpleCommandImpl
	 * @see net.launchpad.vide.flowchart.impl.FlowchartPackageImpl#getSimpleCommand()
	 * @generated
	 */
	int SIMPLE_COMMAND = 5;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SIMPLE_COMMAND__DESCRIPTION = COMMAND_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Code</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SIMPLE_COMMAND__CODE = COMMAND_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Next Command</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SIMPLE_COMMAND__NEXT_COMMAND = COMMAND_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Simple Command</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SIMPLE_COMMAND_FEATURE_COUNT = COMMAND_FEATURE_COUNT + 3;

	/**
	 * The meta object id for the '{@link net.launchpad.vide.flowchart.impl.LogicalExpressionImpl <em>Logical Expression</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see net.launchpad.vide.flowchart.impl.LogicalExpressionImpl
	 * @see net.launchpad.vide.flowchart.impl.FlowchartPackageImpl#getLogicalExpression()
	 * @generated
	 */
	int LOGICAL_EXPRESSION = 6;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOGICAL_EXPRESSION__DESCRIPTION = 0;

	/**
	 * The feature id for the '<em><b>Code</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOGICAL_EXPRESSION__CODE = 1;

	/**
	 * The number of structural features of the '<em>Logical Expression</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOGICAL_EXPRESSION_FEATURE_COUNT = 2;


	/**
	 * The meta object id for the '{@link net.launchpad.vide.flowchart.impl.FunctionalCommandImpl <em>Functional Command</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see net.launchpad.vide.flowchart.impl.FunctionalCommandImpl
	 * @see net.launchpad.vide.flowchart.impl.FlowchartPackageImpl#getFunctionalCommand()
	 * @generated
	 */
	int FUNCTIONAL_COMMAND = 7;

	/**
	 * The feature id for the '<em><b>Code</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTIONAL_COMMAND__CODE = 0;

	/**
	 * The feature id for the '<em><b>Output</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTIONAL_COMMAND__OUTPUT = 1;

	/**
	 * The feature id for the '<em><b>Input</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTIONAL_COMMAND__INPUT = 2;

	/**
	 * The number of structural features of the '<em>Functional Command</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTIONAL_COMMAND_FEATURE_COUNT = 3;


	/**
	 * Returns the meta object for class '{@link net.launchpad.vide.flowchart.Program <em>Program</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Program</em>'.
	 * @see net.launchpad.vide.flowchart.Program
	 * @generated
	 */
	EClass getProgram();

	/**
	 * Returns the meta object for the containment reference list '{@link net.launchpad.vide.flowchart.Program#getBlocks <em>Blocks</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Blocks</em>'.
	 * @see net.launchpad.vide.flowchart.Program#getBlocks()
	 * @see #getProgram()
	 * @generated
	 */
	EReference getProgram_Blocks();

	/**
	 * Returns the meta object for the containment reference list '{@link net.launchpad.vide.flowchart.Program#getFunctionalCommands <em>Functional Commands</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Functional Commands</em>'.
	 * @see net.launchpad.vide.flowchart.Program#getFunctionalCommands()
	 * @see #getProgram()
	 * @generated
	 */
	EReference getProgram_FunctionalCommands();

	/**
	 * Returns the meta object for the attribute '{@link net.launchpad.vide.flowchart.Program#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see net.launchpad.vide.flowchart.Program#getName()
	 * @see #getProgram()
	 * @generated
	 */
	EAttribute getProgram_Name();

	/**
	 * Returns the meta object for class '{@link net.launchpad.vide.flowchart.Block <em>Block</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Block</em>'.
	 * @see net.launchpad.vide.flowchart.Block
	 * @generated
	 */
	EClass getBlock();

	/**
	 * Returns the meta object for the containment reference list '{@link net.launchpad.vide.flowchart.Block#getCommands <em>Commands</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Commands</em>'.
	 * @see net.launchpad.vide.flowchart.Block#getCommands()
	 * @see #getBlock()
	 * @generated
	 */
	EReference getBlock_Commands();

	/**
	 * Returns the meta object for the attribute '{@link net.launchpad.vide.flowchart.Block#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see net.launchpad.vide.flowchart.Block#getName()
	 * @see #getBlock()
	 * @generated
	 */
	EAttribute getBlock_Name();

	/**
	 * Returns the meta object for class '{@link net.launchpad.vide.flowchart.Command <em>Command</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Command</em>'.
	 * @see net.launchpad.vide.flowchart.Command
	 * @generated
	 */
	EClass getCommand();

	/**
	 * Returns the meta object for class '{@link net.launchpad.vide.flowchart.Branching <em>Branching</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Branching</em>'.
	 * @see net.launchpad.vide.flowchart.Branching
	 * @generated
	 */
	EClass getBranching();

	/**
	 * Returns the meta object for the reference '{@link net.launchpad.vide.flowchart.Branching#getTrueBlock <em>True Block</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>True Block</em>'.
	 * @see net.launchpad.vide.flowchart.Branching#getTrueBlock()
	 * @see #getBranching()
	 * @generated
	 */
	EReference getBranching_TrueBlock();

	/**
	 * Returns the meta object for the reference '{@link net.launchpad.vide.flowchart.Branching#getFalseBlock <em>False Block</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>False Block</em>'.
	 * @see net.launchpad.vide.flowchart.Branching#getFalseBlock()
	 * @see #getBranching()
	 * @generated
	 */
	EReference getBranching_FalseBlock();

	/**
	 * Returns the meta object for the reference '{@link net.launchpad.vide.flowchart.Branching#getCondition <em>Condition</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Condition</em>'.
	 * @see net.launchpad.vide.flowchart.Branching#getCondition()
	 * @see #getBranching()
	 * @generated
	 */
	EReference getBranching_Condition();

	/**
	 * Returns the meta object for class '{@link net.launchpad.vide.flowchart.Loop <em>Loop</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Loop</em>'.
	 * @see net.launchpad.vide.flowchart.Loop
	 * @generated
	 */
	EClass getLoop();

	/**
	 * Returns the meta object for the reference '{@link net.launchpad.vide.flowchart.Loop#getBody <em>Body</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Body</em>'.
	 * @see net.launchpad.vide.flowchart.Loop#getBody()
	 * @see #getLoop()
	 * @generated
	 */
	EReference getLoop_Body();

	/**
	 * Returns the meta object for the reference '{@link net.launchpad.vide.flowchart.Loop#getCondition <em>Condition</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Condition</em>'.
	 * @see net.launchpad.vide.flowchart.Loop#getCondition()
	 * @see #getLoop()
	 * @generated
	 */
	EReference getLoop_Condition();

	/**
	 * Returns the meta object for class '{@link net.launchpad.vide.flowchart.SimpleCommand <em>Simple Command</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Simple Command</em>'.
	 * @see net.launchpad.vide.flowchart.SimpleCommand
	 * @generated
	 */
	EClass getSimpleCommand();

	/**
	 * Returns the meta object for the attribute '{@link net.launchpad.vide.flowchart.SimpleCommand#getDescription <em>Description</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Description</em>'.
	 * @see net.launchpad.vide.flowchart.SimpleCommand#getDescription()
	 * @see #getSimpleCommand()
	 * @generated
	 */
	EAttribute getSimpleCommand_Description();

	/**
	 * Returns the meta object for the attribute '{@link net.launchpad.vide.flowchart.SimpleCommand#getCode <em>Code</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Code</em>'.
	 * @see net.launchpad.vide.flowchart.SimpleCommand#getCode()
	 * @see #getSimpleCommand()
	 * @generated
	 */
	EAttribute getSimpleCommand_Code();

	/**
	 * Returns the meta object for the reference '{@link net.launchpad.vide.flowchart.SimpleCommand#getNextCommand <em>Next Command</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Next Command</em>'.
	 * @see net.launchpad.vide.flowchart.SimpleCommand#getNextCommand()
	 * @see #getSimpleCommand()
	 * @generated
	 */
	EReference getSimpleCommand_NextCommand();

	/**
	 * Returns the meta object for class '{@link net.launchpad.vide.flowchart.LogicalExpression <em>Logical Expression</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Logical Expression</em>'.
	 * @see net.launchpad.vide.flowchart.LogicalExpression
	 * @generated
	 */
	EClass getLogicalExpression();

	/**
	 * Returns the meta object for the attribute '{@link net.launchpad.vide.flowchart.LogicalExpression#getDescription <em>Description</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Description</em>'.
	 * @see net.launchpad.vide.flowchart.LogicalExpression#getDescription()
	 * @see #getLogicalExpression()
	 * @generated
	 */
	EAttribute getLogicalExpression_Description();

	/**
	 * Returns the meta object for the attribute '{@link net.launchpad.vide.flowchart.LogicalExpression#getCode <em>Code</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Code</em>'.
	 * @see net.launchpad.vide.flowchart.LogicalExpression#getCode()
	 * @see #getLogicalExpression()
	 * @generated
	 */
	EAttribute getLogicalExpression_Code();

	/**
	 * Returns the meta object for class '{@link net.launchpad.vide.flowchart.FunctionalCommand <em>Functional Command</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Functional Command</em>'.
	 * @see net.launchpad.vide.flowchart.FunctionalCommand
	 * @generated
	 */
	EClass getFunctionalCommand();

	/**
	 * Returns the meta object for the attribute '{@link net.launchpad.vide.flowchart.FunctionalCommand#getCode <em>Code</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Code</em>'.
	 * @see net.launchpad.vide.flowchart.FunctionalCommand#getCode()
	 * @see #getFunctionalCommand()
	 * @generated
	 */
	EAttribute getFunctionalCommand_Code();

	/**
	 * Returns the meta object for the reference list '{@link net.launchpad.vide.flowchart.FunctionalCommand#getOutput <em>Output</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Output</em>'.
	 * @see net.launchpad.vide.flowchart.FunctionalCommand#getOutput()
	 * @see #getFunctionalCommand()
	 * @generated
	 */
	EReference getFunctionalCommand_Output();

	/**
	 * Returns the meta object for the reference list '{@link net.launchpad.vide.flowchart.FunctionalCommand#getInput <em>Input</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Input</em>'.
	 * @see net.launchpad.vide.flowchart.FunctionalCommand#getInput()
	 * @see #getFunctionalCommand()
	 * @generated
	 */
	EReference getFunctionalCommand_Input();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	FlowchartFactory getFlowchartFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link net.launchpad.vide.flowchart.impl.ProgramImpl <em>Program</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see net.launchpad.vide.flowchart.impl.ProgramImpl
		 * @see net.launchpad.vide.flowchart.impl.FlowchartPackageImpl#getProgram()
		 * @generated
		 */
		EClass PROGRAM = eINSTANCE.getProgram();

		/**
		 * The meta object literal for the '<em><b>Blocks</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PROGRAM__BLOCKS = eINSTANCE.getProgram_Blocks();

		/**
		 * The meta object literal for the '<em><b>Functional Commands</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PROGRAM__FUNCTIONAL_COMMANDS = eINSTANCE.getProgram_FunctionalCommands();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute PROGRAM__NAME = eINSTANCE.getProgram_Name();

		/**
		 * The meta object literal for the '{@link net.launchpad.vide.flowchart.impl.BlockImpl <em>Block</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see net.launchpad.vide.flowchart.impl.BlockImpl
		 * @see net.launchpad.vide.flowchart.impl.FlowchartPackageImpl#getBlock()
		 * @generated
		 */
		EClass BLOCK = eINSTANCE.getBlock();

		/**
		 * The meta object literal for the '<em><b>Commands</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference BLOCK__COMMANDS = eINSTANCE.getBlock_Commands();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute BLOCK__NAME = eINSTANCE.getBlock_Name();

		/**
		 * The meta object literal for the '{@link net.launchpad.vide.flowchart.impl.CommandImpl <em>Command</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see net.launchpad.vide.flowchart.impl.CommandImpl
		 * @see net.launchpad.vide.flowchart.impl.FlowchartPackageImpl#getCommand()
		 * @generated
		 */
		EClass COMMAND = eINSTANCE.getCommand();

		/**
		 * The meta object literal for the '{@link net.launchpad.vide.flowchart.impl.BranchingImpl <em>Branching</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see net.launchpad.vide.flowchart.impl.BranchingImpl
		 * @see net.launchpad.vide.flowchart.impl.FlowchartPackageImpl#getBranching()
		 * @generated
		 */
		EClass BRANCHING = eINSTANCE.getBranching();

		/**
		 * The meta object literal for the '<em><b>True Block</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference BRANCHING__TRUE_BLOCK = eINSTANCE.getBranching_TrueBlock();

		/**
		 * The meta object literal for the '<em><b>False Block</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference BRANCHING__FALSE_BLOCK = eINSTANCE.getBranching_FalseBlock();

		/**
		 * The meta object literal for the '<em><b>Condition</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference BRANCHING__CONDITION = eINSTANCE.getBranching_Condition();

		/**
		 * The meta object literal for the '{@link net.launchpad.vide.flowchart.impl.LoopImpl <em>Loop</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see net.launchpad.vide.flowchart.impl.LoopImpl
		 * @see net.launchpad.vide.flowchart.impl.FlowchartPackageImpl#getLoop()
		 * @generated
		 */
		EClass LOOP = eINSTANCE.getLoop();

		/**
		 * The meta object literal for the '<em><b>Body</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference LOOP__BODY = eINSTANCE.getLoop_Body();

		/**
		 * The meta object literal for the '<em><b>Condition</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference LOOP__CONDITION = eINSTANCE.getLoop_Condition();

		/**
		 * The meta object literal for the '{@link net.launchpad.vide.flowchart.impl.SimpleCommandImpl <em>Simple Command</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see net.launchpad.vide.flowchart.impl.SimpleCommandImpl
		 * @see net.launchpad.vide.flowchart.impl.FlowchartPackageImpl#getSimpleCommand()
		 * @generated
		 */
		EClass SIMPLE_COMMAND = eINSTANCE.getSimpleCommand();

		/**
		 * The meta object literal for the '<em><b>Description</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute SIMPLE_COMMAND__DESCRIPTION = eINSTANCE.getSimpleCommand_Description();

		/**
		 * The meta object literal for the '<em><b>Code</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute SIMPLE_COMMAND__CODE = eINSTANCE.getSimpleCommand_Code();

		/**
		 * The meta object literal for the '<em><b>Next Command</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference SIMPLE_COMMAND__NEXT_COMMAND = eINSTANCE.getSimpleCommand_NextCommand();

		/**
		 * The meta object literal for the '{@link net.launchpad.vide.flowchart.impl.LogicalExpressionImpl <em>Logical Expression</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see net.launchpad.vide.flowchart.impl.LogicalExpressionImpl
		 * @see net.launchpad.vide.flowchart.impl.FlowchartPackageImpl#getLogicalExpression()
		 * @generated
		 */
		EClass LOGICAL_EXPRESSION = eINSTANCE.getLogicalExpression();

		/**
		 * The meta object literal for the '<em><b>Description</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute LOGICAL_EXPRESSION__DESCRIPTION = eINSTANCE.getLogicalExpression_Description();

		/**
		 * The meta object literal for the '<em><b>Code</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute LOGICAL_EXPRESSION__CODE = eINSTANCE.getLogicalExpression_Code();

		/**
		 * The meta object literal for the '{@link net.launchpad.vide.flowchart.impl.FunctionalCommandImpl <em>Functional Command</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see net.launchpad.vide.flowchart.impl.FunctionalCommandImpl
		 * @see net.launchpad.vide.flowchart.impl.FlowchartPackageImpl#getFunctionalCommand()
		 * @generated
		 */
		EClass FUNCTIONAL_COMMAND = eINSTANCE.getFunctionalCommand();

		/**
		 * The meta object literal for the '<em><b>Code</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute FUNCTIONAL_COMMAND__CODE = eINSTANCE.getFunctionalCommand_Code();

		/**
		 * The meta object literal for the '<em><b>Output</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference FUNCTIONAL_COMMAND__OUTPUT = eINSTANCE.getFunctionalCommand_Output();

		/**
		 * The meta object literal for the '<em><b>Input</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference FUNCTIONAL_COMMAND__INPUT = eINSTANCE.getFunctionalCommand_Input();

	}

} //FlowchartPackage
